<script>
import { ref, onMounted } from "vue";
import axios from "axios";
import { useRoute, useRouter } from "vue-router";

export default {
  setup() {
    // Reactive state
    const bukus = ref([]);
    const userId = ref();

    // Vue router
    const route = useRoute();
    const router = useRouter();
    const isFromCart = route.params.source === "cart";

    // Method to fetch cart data
    const fetchCartData = () => {
      axios
        .get(`http://localhost:8000/api/keranjang?user_id=${userId.value}`)
        .then((response) => {
          const cartData = response.data.data;
          const bookPromises = cartData.map((cartItem) => {
            return axios
              .get(`http://localhost:8000/api/buku/${cartItem.buku_id}`)
              .then((bookResponse) => {
                const book = bookResponse.data.bukus;
                return {
                  buku_id: cartItem.buku_id,
                  title: book.title,
                  author: book.author,
                  price: book.price,
                  quantity: cartItem.qty,
                  cover: book.cover,
                };
              })
              .catch((error) => {
                console.log("Error fetching book details:", error);
                return null;
              });
          });

          Promise.all(bookPromises).then((bookDetails) => {
            const validBookDetails = bookDetails.filter((book) => book !== null);
            bukus.value = validBookDetails;
          });
        })
        .catch((error) => {
          console.log("Error fetching cart data:", error);
        });
    };

    // Method to load book details from catalog
    const loadBookFromCatalog = async () => {
      try {
        const bookResponse = await axios.get(`http://localhost:8000/api/buku/${route.params.buku_id}`);
        const book = bookResponse.data.bukus;
        const loadedBook = {
          buku_id: route.params.buku_id,
          title: book.title,
          author: book.author,
          price: book.price,
          quantity: route.params.qty,
          cover: book.cover,
        };
        bukus.value = [loadedBook];
      } catch (error) {
        console.log("Error fetching book details:", error);
      }
    };

    // Fetch cart data when component is mounted
    onMounted(() => {
      userId.value = 1; // Get userId from state or local storage after user login

      if (!isFromCart) {
        loadBookFromCatalog(); // Load book from catalog if not from cart
      } else {
        fetchCartData(); // Fetch cart data if from cart
      }
    });

    // Method to calculate total price of a book
    const calculateTotal = (buku) => {
      return buku.price * buku.quantity;
    };

    // Method to calculate grand total price of all books
    const calculateGrandTotal = () => {
      let grandTotal = 0;
      for (let buku of bukus.value) {
        grandTotal += calculateTotal(buku);
      }
      return grandTotal;
    };

    // Method to handle form submission (adding order)
    const addToOrder = () => {
      const data = {
        total: calculateGrandTotal(),
        bukus: bukus.value,
        status: "pending",
        user_id: 1,
      };

      if (isFromCart) {
        // Delete each item from the cart
        bukus.value.forEach((item) => {
          axios
            .delete(`http://localhost:8000/api/keranjang/${item.buku_id}`, {
              data: {
                user_id: userId.value,
                buku_id: item.buku_id,
              },
            })
            .then((response) => {
              console.log("Item deleted successfully");
              // Remove the deleted item from the bukus array
              bukus.value = bukus.value.filter((buku) => buku.buku_id !== item.buku_id);
            })
            .catch((error) => {
              console.error("Error deleting item:", error);
            });
        });
      }

      axios
        .post("http://localhost:8000/api/pesanan", data)
        .then((response) => {
          console.log("Order submitted successfully:", response.data);
          // Redirect to MyOrder page after successful submission
          router.push({ name: "pages.myOrder" });
        })
        .catch((error) => {
          console.error("Error submitting Order:", error.response.data);
          // Handle error (e.g., show an error message)
        });
    };

    return {
      bukus,
      calculateTotal,
      calculateGrandTotal,
      addToOrder,
      isFromCart,
    };
  },
};
</script>

<template>
  <section class="pt-5">
    <div class="container">
      <div class="row pt-5">
        <h1>Checkout</h1>
        <div class="col">
          <div class="card">
            <div class="card-body my-1 mx-2">
              <div class="card-text mt-3">Pesananku</div>
              <table class="table table-sm">
                <tbody>
                  <tr v-if="bukus.length === 0">
                    <td colspan="3">Tidak ada buku dalam pesanan</td>
                  </tr>
                  <tr v-else-if="bukus.length === 1">
                    <th scope="row" class="p-3 frame" style="width: 20%">
                      <img :src="bukus[0].cover" class="card-img-top pb-3"
                        style="object-fit: cover; object-position: center" alt="" />
                    </th>
                    <td class="text-wrap py-3" style="width: 50%">
                      {{ bukus[0].title }}
                    </td>
                    <td class="py-3 text-right" style="width: 30%">
                      {{ bukus[0].quantity }} x Rp{{ bukus[0].price.toLocaleString("id-ID") }}
                    </td>
                  </tr>
                  <tr v-else v-for="(buku, index) in bukus" :key="index">
                    <th scope="row" class="p-3 frame" style="width: 20%">
                      <img :src="buku.cover" class="card-img-top pb-3"
                        style="object-fit: cover; object-position: center" alt="" />
                    </th>
                    <td class="text-wrap py-3" style="width: 50%">
                      {{ buku.title }}
                    </td>
                    <td class="py-3 text-right" style="width: 30%">
                      {{ buku.quantity }} x Rp{{ bukus[0].price.toLocaleString("id-ID") }}
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
        <div class="col-sm-6" style="max-width: 35%">
          <form @submit.prevent="addToOrder">
            <div class="card border-0" style="background-color: #f1f1f1">
              <div class="card-body d-flex flex-column">
                <h5 class="card-title">Rincian Pembayaran</h5>
                <div class="d-flex justify-content-between my-3">
                  <p class="card-text">Total Pembayaran</p>
                  <p class="card-text">Rp{{ calculateGrandTotal().toLocaleString("id-ID", { minimumFractionDigits: 2, })
                    }}</p>
                </div>
                <button type="submit" class="btn btn-primary">Bayar</button>
              </div>
            </div>
          </form>
        </div>
      </div>
    </div>
  </section>
</template>